<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Category;
use App\Models\CategoryAtributes;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\JsonResponse;
use Yajra\DataTables\Facades\DataTables;

class CategoryAttributesController extends Controller
{
    public function index()
    {
        $categoryatributes = [];
        
        return view('admin.categoryatributes.index', compact('categoryatributes'));

    }

    public function getCategoryAttributeList(Request $request)
    {
        $sqlBuilder = CategoryAtributes::select('category_atributes.*')
            ->with('categories');;

        return DataTables::of($sqlBuilder)
        ->filter(function ($query) use ($request) {
            if ($request->has('search') && !empty($request->search['value'])) {
            $query->where('category_atributes.name', 'ilike', "%" . $request->search['value'] . "%");
            }
        })
        ->addColumn('category_name', function ($data) {
            return $data->categories->name_with_parent_category_name ?? 'N/A';
        })
            ->editColumn('status', function ($data) {
            return '<div class="status">
                <div class="form-check form-switch ">
                    <input class="form-check-input status-checkbox" type="checkbox" role="switch" id="SwitchCheck4" data-url="'. route('admin.category_atributes.status', ['id' => $data->id]) .'" data-id="'.$data->id.'" '.(!empty($data->status) && $data->status == 1 ? 'checked' : '').' />
                </div>
                </div>';
            })
            ->addColumn('action', function ($data) {
            $html = '<div class="dropdown">
                        <a href="#" class="btn btn-soft-secondary btn-sm" role="button" id="dropdownMenuLink5" data-bs-toggle="dropdown" aria-expanded="false">
                            <i class="ri-more-2-fill"></i>
                        </a>
                        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink5">
                            <li><a class="dropdown-item" href="' . route('admin.category_atributes.edit', ['id' => $data->id]) . '">Edit</a></li>
                            <li><a class="dropdown-item delete-btn" data-url="' . route('admin.category_atributes.destroy', ['id' => $data->id]) . '">Delete</a></li>
                        </ul>
                        </div>';
            return $html;
            })
            ->rawColumns(['category_name','status','action'])
            ->make(true);
    }

    public function create(){
        $categoryatribute = "";
        $categories = Category::whereNotNull('parent_id')->where('status', 1)->get();
        return view('admin.categoryatributes.create', compact('categoryatribute','categories'));

    }

    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|string|max:255',
            'name_ar' => 'required|string|max:255',
            'status' => 'required|in:0,1',
            'category_id' => 'required',
        ];
    
        $validator = Validator::make($request->all(), $rules);
    
        if ($validator->fails()) {
            return response()->json([
                'status' => 'error',
                'errors' => $validator->errors(),
            ], 422);
        }
    
        if ($request->id) {
            $categoryAttribute = CategoryAtributes::find($request->id);
    
            if (!$categoryAttribute) {
                return response()->json(['status' => 'error', 'message' => 'Category Atribute not found'], 404);
            }
    
            $existingCategoryAttribute = CategoryAtributes::where('name', $request->name)
                ->where('id', '!=', $request->id)
                ->where('category_id', $request->category_id)
                ->first();
    
            if ($existingCategoryAttribute) {
                return response()->json([
                    'status' => 'error',
                    'errors' => [
                        'name' => ['The Category Atribute name already exists.']
                    ]
                ], 422);
            }
    
            $categoryAttribute->name = $request->name;
            $categoryAttribute->name_ar = $request->name_ar;
            $categoryAttribute->category_id = $request->category_id;
            $categoryAttribute->status = $request->status;
            $categoryAttribute->save();
    
            return response()->json(['status' => 'success', 'message' => 'Category Atribute updated successfully']);
        } else {
            $existingCategoryAtributes = CategoryAtributes::where('name', $request->name)->where('category_id', $request->category_id)->first();
    
            if ($existingCategoryAtributes) {
                return response()->json([
                    'status' => 'error',
                    'errors' => [
                        'name' => ['The Category Atribute name already exists.']
                    ]
                ], 422);
            }
    
            $categoryAttribute = CategoryAtributes::create([
                'name' => $request->name,
                'name_ar' => $request->name_ar,
                'category_id' => $request->category_id,
                'status' => $request->status,
            ]);
    
            return response()->json(['status' => 'success', 'message' => 'Category Atribute added successfully', 'emirate' => $categoryAttribute]);
        }
    }
    


  
    public function edit($id) {
        $categoryatribute = CategoryAtributes::with('categories')->findOrFail($id);
        $categories = Category::orderBy('id', 'desc')->whereNotNull('parent_id')->where('status', 1)->get();
        return view('admin.categoryatributes.create', compact('categoryatribute','categories'));
    }

    public function destroy($id): JsonResponse
    {
        try {
            $categoryatribute = CategoryAtributes::findOrFail($id);           
            $categoryatribute->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Category Atribute deleted successfully.'
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'Category Atribute  not found.'
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'An error occurred while deleting the company.'
            ], 500);
        }
    }

    public function statusChange(Request $request, $id) {
        $categoryatribute = CategoryAtributes::find($id);

        if (!$categoryatribute) {
            return response()->json([
                'status' => 'error',
                'message' => 'Category Atribute  not found.'
            ], 404);
        }
    
        $categoryatribute->status = $request->status;
        $categoryatribute->save();
    
        return response()->json([
            'status' => 'success',
            'message' => 'Category Atribute status updated successfully.'
        ]);
    }
}
